%define major   0
%define libname %mklibname %{name} %{major}
%define devname %mklibname %{name} -d

%define uname   SPIRV-Tools
%define vulkansdk sdk-1.3.231.1

Name:           spirv-tools
# Check https://github.com/KhronosGroup/SPIRV-Tools/releases to see if any
# matches the SDK tag, or take the last tag before the commit hash.
Version:        2022.4
Release:        %mkrel 2
Summary:        API and commands for processing SPIR-V modules
Group:          System/Libraries
License:        ASL 2.0
URL:            https://github.com/KhronosGroup/SPIRV-Tools
Source0:        https://github.com/KhronosGroup/SPIRV-Tools/archive/%{vulkansdk}/%{uname}-%{vulkansdk}.tar.xz

Patch1:         spirv-tools-soversion.patch

# https://github.com/KhronosGroup/SPIRV-Tools/pull/3906
Patch2:         0001-CMake-FIx-pkg-config-libdir-with-absolute-CMAKE_INST.patch

BuildRequires:  cmake
BuildRequires:  python3
BuildRequires:  spirv-headers
Obsoletes:  spirv-tools-sdk
Provides:     spirv-tools-sdk = %{version}-%{release}

%description
The package includes an assembler, binary module parser,
disassembler, and validator for SPIR-V.

%package -n %{libname}
Summary:        Library files for SPIR-V tools
Group:          System/Libraries
Obsoletes:  lib64spirv-tools-sdk0
Provides:     lib64spirv-tools-sdk0 = %{version}-%{release}

%description -n %{libname}
Library files for SPIR-V tools.

%package -n %{devname}
Summary:        Development files for SPIR-V tools
Group:          Development/Libraries
Requires:       %{libname} = %{version}-%{release}
Requires:       spirv-headers
Provides:       %{name}-devel = %{version}-%{release}
Obsoletes:   lib64spirv-tools-sdk-devel
Provides:     lib64spirv-tools-sdk-devel = %{version}-%{release}

%description -n %{devname}
Development files for SPIR-V tools.

%prep
%autosetup -p1 -n %{uname}-%{vulkansdk}

%build
%cmake \
    -DSPIRV_TOOLS_BUILD_STATIC=OFF \
    -DSPIRV_TOOLS_SOVERSION=%{major} \
    -DSPIRV_TOOLS_VERSION=%{version} \
    -DSPIRV-Headers_SOURCE_DIR=%{_prefix} \
    -DPYTHON_EXECUTABLE=%{__python3}
%cmake_build

%install
%cmake_install

%files
%{_bindir}/spirv-as
%{_bindir}/spirv-cfg
%{_bindir}/spirv-dis
%{_bindir}/spirv-lesspipe.sh
%{_bindir}/spirv-link
%{_bindir}/spirv-lint
%{_bindir}/spirv-opt
%{_bindir}/spirv-reduce
%{_bindir}/spirv-val

%files -n %{libname}
%{_libdir}/lib%{uname}-{diff,link,lint,opt,reduce,shared}.so.%{major}
%{_libdir}/lib%{uname}-{diff,link,lint,opt,reduce,shared}.so.%{version}
%{_libdir}/lib%{uname}.so.%{major}
%{_libdir}/lib%{uname}.so.%{version}

%files -n %{devname}
%{_includedir}/%{name}/
%{_libdir}/cmake/%{uname}{,-diff,-link,-lint,-opt,-reduce}/
%{_libdir}/pkgconfig/%{uname}-shared.pc
%{_libdir}/pkgconfig/%{uname}.pc
%{_libdir}/lib%{uname}-{diff,link,lint,opt,reduce,shared}.so
%{_libdir}/lib%{uname}.so


%changelog
* Thu Oct 26 2023 tex - 2022.4-2pclos2023
- rebuild against updates

* Tue Oct 10 2023 tex - 2022.4-1pclos2023
- Version 2022.4, Vulkan SDK 1.3.231.1
